<?php
	if (rex::isBackend()) {
		rex_view::addCssFile($this->getAssetsUrl('redactor.css'));
		rex_view::addJsFile($this->getAssetsUrl('redactor.js'));
		
		$plugins = glob(rex_path::addonAssets('rex_redactor', 'plugins').'/*.js');
		foreach ($plugins as $plugin) {
			rex_view::addJsFile($this->getAssetsUrl('plugins/'.substr($plugin, strlen(rex_path::addonAssets('rex_redactor', 'plugins'))+1)));
		}
		
		//Start - get redactor-profiles
			$sql = rex_sql::factory();
			$profiles = $sql->setQuery("SELECT `name`, `language`, `redactor_configuration` FROM `".rex::getTablePrefix()."redactor_profiles` ORDER BY `name` ASC")->getArray();
			unset($sql);
			
			$javascriptCode = '';
			$javascriptCode .= '$(document).on(\'ready pjax:success\',function() {';
			foreach ($profiles as $profile) {
				rex_view::addJsFile($this->getAssetsUrl('langs/'.$profile['language'].'.js'));
				
				$javascriptCode .= '$(\'.redactorEditor-'.$profile['name'].'\').redactor({';
				$javascriptCode .= 'lang: \''.$profile['language'].'\',';
				
				$javascriptCode .= $this->getConfig('redactor_enhancements');
				
				$javascriptCode .= $profile['redactor_configuration'];
				
				$javascriptCode .= '});';
			}
			$javascriptCode .= '});';
			
			if (!rex_file::put(rex_path::addonAssets('rex_redactor', 'cache/redactor_profiles.js').'', $javascriptCode)) {
				echo 'js-file konnte nicht gespeichert werden';
			}
			
			rex_view::addJsFile($this->getAssetsUrl('cache/redactor_profiles.js'));
		//End - get redactor-profiles
		
		//Start - include custom js
			$customJS = $this->getConfig('custom_js');
			
			if (!rex_file::put(rex_path::addonAssets('rex_redactor', 'cache/custom_js.js').'', $customJS)) {
				echo 'customJS konnte nicht gespeichert werden';
			}
			
			rex_view::addJsFile($this->getAssetsUrl('cache/custom_js.js'));
		//End - include custom js
		
		//Start - include custom css
			$customCSS = $this->getConfig('custom_css');
			
			if (!rex_file::put(rex_path::addonAssets('rex_redactor', 'cache/custom_css.css').'', $customCSS)) {
				echo 'customCSS konnte nicht gespeichert werden';
			}
			
			rex_view::addCssFile($this->getAssetsUrl('cache/custom_css.css'));
		//End - include custom css	
	
		//Start use OUTPUT_FILTER-EP to use an custom callback
			rex_extension::register('OUTPUT_FILTER', function($param) {
				$page = rex_request('page', 'string');
				$referrer = rex_request('referrer', 'string');
				$opener_input_field = rex_request('opener_input_field', 'string');
				$pluginname = rex_request('pluginname', 'string');
				
				$content = $param->getSubject();
				
				if ($page == 'mediapool/media' && $referrer == 'redactor') {
					$content = preg_replace("|javascript:selectMedia\(\'(.*)\', \'(.*)\'\);|", "javascript:window.opener.$('#".$opener_input_field."').redactor('".$pluginname.".selectMedia', '$1', '$2');self.close();", $content);
				} else if ($page == 'linkmap' && $referrer == 'redactor') {
					$content = preg_replace("|javascript:insertLink\(\'(.*)\',\'(.*)\'\);|",  "javascript:window.opener.$('#".$opener_input_field."').redactor('".$pluginname.".insertLink', '$1', '$2');self.close();", $content);
				}
				
				return $content;
			});
		//End use OUTPUT_FILTER-EP to use an custom callback
	}
?>